<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="800px">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="80px"
    >
      <el-form-item label="问题" prop="question">
        <el-input v-model="formData.question" placeholder="请输入问题" />
      </el-form-item>
      <el-form-item label="关键词" prop="skillKey">
        <el-input v-model="formData.skillKey" placeholder="请输入关键词，,以“,”分割" />
      </el-form-item>
      <el-form-item label="答案" prop="content">
        <Editor v-model:modelValue="formData.content" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="DialogSkill" setup>
import * as SkillApi from '@/api/clue/skill'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  question: '',
  skillKey: '',
  content: ''
})
const formRules = reactive({
  question: [{ required: true, message: '问题不能为空', trigger: 'blur' }],
  content: [{ required: true, message: '答案不能为空', trigger: 'blur,change' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type, id) => {
  dialogVisible.value = true
  dialogTitle.value = type == 'create' ? '新增话术' : '修改话术'
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await SkillApi.getSkill(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    if (formType.value === 'create') {
      await SkillApi.createSkill(formData.value)
      message.success(t('common.createSuccess'))
    } else {
      await SkillApi.updateSkill(formData.value)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    question: '',
    skillKey: '',
    content: ''
  }
  formRef.value?.resetFields()
}
</script>
